/// icesound wanna-be c-coded replacement for size-reduction and education
/// goingnuts 20130303

#include <stdlib.h>
#include <stdio.h>
#include <X11/Xatom.h>
#include <X11/Xlib.h>
#include <X11/Xos.h>

#define XA_GUI_EVENT_NAME "ICEWM_GUI_EVENT"

enum GUIEvent {
    geStartup,             
    geShutdown,            
    geRestart,
    geCloseAll,
    geLaunchApp,
    geWorkspaceChange,
    geWindowOpened, 
    geWindowClosed, 
    geDialogOpened,
    geDialogClosed,
    geWindowMax,   
    geWindowRestore,  
    geWindowMin,     
    geWindowHide,       
    geWindowRollup,      
    geWindowMoved,
    geWindowSized,
    geWindowLower
};

void play(int sound) {
	
	char * samplefile = NULL;
	char temp[512];	
	int fd;
	
	switch (sound){
		
		case geStartup:
			samplefile="/root/.icewm/sounds/startup.wav";
			break;
			
		case geShutdown:
			samplefile="/root/.icewm/sounds/shutdown.wav";
			break;
		
		case geRestart:
			samplefile="/root/.icewm/sounds/restart.wav";
			break;
		
		case geCloseAll:
			samplefile="/root/.icewm/sounds/closeAll.wav";
			break;
		
		case geLaunchApp:
			samplefile="/root/.icewm/sounds/launchApp.wav";
			break;
		
		case geWorkspaceChange:
			samplefile="/root/.icewm/sounds/workspaceChange.wav";
			break;
		
    	case geWindowOpened:
			samplefile="/root/.icewm/sounds/windowOpen.wav";
			break;
			
		case geWindowClosed:
			samplefile="/root/.icewm/sounds/windowClose.wav";
			break;
			
		case geDialogOpened:
			samplefile="/root/.icewm/sounds/dialogOpen.wav";
			break;
			
		case geDialogClosed:
			samplefile="/root/.icewm/sounds/dialogClose.wav";
			break;
			
		case geWindowMin:
			samplefile="/root/.icewm/sounds/windowMin.wav";
			break;
			
		case geWindowMax:
			samplefile="/root/.icewm/sounds/windowMax.wav";
			break;
			
		case geWindowRestore:
			samplefile="/root/.icewm/sounds/windowRestore.wav";
			break;
			
		case geWindowHide:
			samplefile="/root/.icewm/sounds/windowHide.wav";
			break;
			
		case geWindowRollup:
			samplefile="/root/.icewm/sounds/windowRollup.wav";
			break;
			
		case geWindowLower:
    
			samplefile="/root/.icewm/sounds/windowLower.wav";
			break;
			
		case geWindowSized:
			samplefile="/root/.icewm/sounds/windowSized.wav";
			break;
			
		case geWindowMoved:
			samplefile="/root/.icewm/sounds/windowMoved.wav";
			break;
	}
	
	///use wavplay
	if (samplefile) {
		///check if file exist
		fd = open(samplefile, O_RDONLY);
    	if (fd < 0) {
        	printf("Error: Could not open %s\n", samplefile);
        	return;
		} else {
			sprintf(temp, "wavplay %s &", samplefile);
			system((char *)temp);
		}
	}
}


int main(int argc, char *argv[]) {
	
	/// check device
	int pcm;
	pcm = open("/dev/dsp", O_WRONLY);
    if (pcm < 0) {
    	printf("Error: Could not open /dev/dsp.\n");
    	return 1;
	}
	
	char    *dpyname = NULL;
	Display * display = NULL;
	Window root = None;
	Atom _GUI_EVENT = None;
  
	if	(NULL == (display = XOpenDisplay(dpyname))) {
		printf("Can't open display: %s. X must be running and $DISPLAY set.\n",
		XDisplayName(dpyname));
		return 0;
	}

    root = RootWindow(display, DefaultScreen(display));
    _GUI_EVENT = XInternAtom(display, XA_GUI_EVENT_NAME, False);
    XSelectInput(display, root, PropertyChangeMask);

    struct timeval last;
    gettimeofday(&last, NULL);
    	
	while(1) {

		while (XPending(display)) {
			XEvent xev;
			XNextEvent(display, &xev);
			
			switch(xev.type) {
				case PropertyNotify:
					if (xev.xproperty.atom == _GUI_EVENT &&
						xev.xproperty.state == PropertyNewValue) {
                    	
						Atom type; int format;
						unsigned long nitems, lbytes;
						unsigned char *propdata;
						int gev = -1;

						if (XGetWindowProperty(display, root, _GUI_EVENT,
							0, 3, False, _GUI_EVENT,
 							&type, &format, &nitems, &lbytes,
							&propdata) == Success && propdata) {
								
							gev = *(char *) propdata;
							XFree(propdata);
						}

						/// Recieved restart event?
						if(geRestart == gev) {
							printf("Recieved restart event\n");
							return 0;
						}

						struct timeval now;
						gettimeofday(&now, NULL);

						if	((now.tv_sec - last.tv_sec) >= 2 ||
							((now.tv_sec - last.tv_sec) * 1000000 +
							now.tv_usec - last.tv_usec) > 500000) {

							last = now;
							play(gev);           
						}
					}
					break;
			}
		}
		usleep(10000);
    }
    if (display) XCloseDisplay(display);
	return 0; 
}
